\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{amssymb}
\usepackage{graphicx}
\usepackage{float}
\usepackage{sectsty}
\usepackage{url, lipsum}
\newcommand{\HRule}[1]{\rule{\linewidth}{#1}}
\renewcommand{\thepage}{}
\begin{document}
\title{ 
        \includegraphics[width=0.8\textwidth]{logo_nouveau.jpg}
        \\ [2.0cm]
        
		\\ \normalsize \textsc{Projet d'ingénieurie Logiciel}
		\HRule{0.5pt} \\
		\LARGE \textbf{\uppercase{Rapport Tweetoscope}}
		\HRule{1pt} \\   }

\author{ \normalsize Réalisé par:
          Ala Ghardaddou\\
          Seifedine Bouguila\\
          Souhir Amri
        \normalsize  \vspace*{1\baselineskip} }

\maketitle

\newpage       

\section{Introduction}

This project was assigned to us in the software engineering class. 
We are given an application that connects to Twitter API, filters out Tweets based on different filtering strategies (language, country code..), extracts the hashtags, counts how many times each hashtag appears in all the streamed Tweets, and displays the 5 most popular ones, sorted by the number of occurrences. However, it is not designed to handle a high volume of tweets and it is not fault tolerant. Our purpose is to refactor the application given to be able to scale it up using Kafka, Docker and Kubernetes.

\section{Secrets and Git}

We don't think it is a good idea to add the BEARER-TOKEN of the twitter account to the git repo. Git is designed to allow, even promote, the free distribution of code. A git repository is meant to share work with your team to collaborate and is not supposed to store sensitive information especially if it is public. An ill-intentioned person that has access to our git can use the BEARER-TOKEN without our knowledge.
\section{Architectural Choices}

We will proceed with the same structure used in the wikimedia labwork. 
We will create 4 topics : 
\begin{itemize}

\item {topic "producer" : topic that holds all the tweets sent whether by the online tweet producers that connect to the tweet API or by the offline tweets producers that read from a set of crafted tweets.}
\item {topic "filter" : topic that holds the filtered tweets. }
\item {topic "extractor" : topic that holds the hashtags extracted from the tweets. }
\item {topic "counter" : topic that holds each hashtag with its count. }
\end{itemize}

In the suggested architecture, we will have : 
\begin{itemize}
\item {First, we will create a service tweetoscope producer that listens to the twitter API and holds the different events in the "producer" topic.
\item{Second, we will create a filtering service that reads from the "producer" topic and publishes to the "filter " topic the tweets selected according to the filtering strategy. We added a filtering strategy based on the creation date of the tweets and publishes the tweets published after the chosen date. }
\item{Third, we will create an extractor service that reads from the "filter" topic and publishes to the "extractor" topic the hashtags extracted from the tweets.}
\item{Then, we will create an aggregator service that reads from the "extractor" topic and publishes the counts the number of occurrences of every hashtag and publishes it to the "counter" topic  }
\item{Last but not least, we will create a visualizor service who will read from the "counter" topic and displays the results on the leader board. }
\end{itemize}


\section{Risk Analysis}
\subsection{Initial Risk Analysis}
The first threat in this architecture is the crash of Zookeeper. If Zookeeper shuts down, the whole application will crash. \\
Since we are using a single broker, if the broker crashes , all the application crashes and we will lose our data. That's why in the docker part, we will use two Kafka brokers to improve fault toleration. \\
The services are very important since they are the ones to process the tweets to find the final results. If one of the services breaks fail, the application will not shut down but will end up giving erroneous results.


\section{What we've learned from this project }

This project has helped us put in practise what we learnt during the labs and the courses of software engineering. It was hard for us to follow the pace of the labs so it was a good thing that we took the time to learn: 
\begin{itemize}
    \item{How to design an architecture for an complicated application with services using Kafka.}
    \item{How to take the application you've developed and make each of its components run in a separate Docker container}
    \item {Run several containers with docker\_compose}
    \item {Deploy the application using miniKube}
    \item{implement à CI/CD  pipeline on Gitlab Student}
    
\end{itemize}





















\end{document}
